package week09

trait Function[-T,U] {
  def apply(input: T): U
  // egy Pet->String függvény megfelel Cat->String függvénynek is
}

object getNameFunction extends Function[NamedObject, String] {
  override def apply(input: NamedObject): String = input.name
}

trait FunkyCovariant[+T] {
  def m: T
  val c: T
  //def bad(t: T): Unit
  def good(f: T=>String): Int
  def good2: (T=>String)=>Int
  //def good3: (T=>String)=>((String=>T)=>Int))
  //def badAgain(g: (T=>String)=>Int ): Unit
  def badAgain(g: (String=>T)=>Int ): Unit
}

object FunctionMain extends App {
  def doSomethingWithAPet[U](pet: Pet, f: Function[Pet,U]): U = f(pet)
  /*def petIdentifier = {
    case Cat(x) if x.equals("Tibi") => "Ez egy macska"
    case Dog(x) => "Ez egy kutya"
  }*/

  //def petOptionIdentifier = petIdentifier.lift
  //println( petIdentifier.isDefinedAt( Cat("Morcos") ) )

  // C[+T]{ def foreach[U]( f: T=>U ): Unit }
  // C[+T]{ def foreach[U]( f: Function[T,U] ): Unit } T < Ty
  // C[+Ty]{ def foreach[U]( f: Function[Ty,U] ): Unit } T < Ty --> Function[Ty,U] < Function[T,U]
}