package week05

import org.scalatest.concurrent.{Signaler, TimeLimitedTests}
import org.scalatest.flatspec.AnyFlatSpec
import org.scalatest.time.{Millis, Span}

import scala.util.Random

class GyakorlatTeszt extends AnyFlatSpec with TimeLimitedTests {
  val timeLimit: Span = Span(1000, Millis)
  override val defaultTestSignaler: Signaler = new Signaler {
    override def apply(testThread: Thread): Unit = {
      println("Ez a teszt túl sokáig fut.")
      testThread.stop()
    } //unsafe, never használd.
  }

  def generateIntList(length: Int, range: Int, positives: Boolean): List[Int] = Random.nextInt(length) match {
    case 0 => Nil
    case _ => {
      val head = Random.nextInt(range);
      (if (positives) head else (head - range / 2)) :: generateIntList(length, range, positives)
    }
  }
/*
  "danteszt" should "replace 0s by 000, 1s by 111" in {
    for (i <- 1 to 1000 ) {
      val s = Random.nextInt().toBinaryString.drop(0)
      assert(Gyakorlat.dante( s ) == s.flatMap( c => c match { case '0' => "000" ; case '1' => "111"}), "teszteset: " + s )
    }
  }

  def generateIntList: List[Int] = Random.nextInt(20) match {
    case 0 => Nil
    case _ => Random.nextInt() :: generateIntList
  }
  "searchtree" should "insert and find correctly" in {
    for (i <- 1 to 1000) {
      val list = generateIntList;
      val inserted = list.foldLeft[SearchTree](EmptyTree) { (tree,value) => tree.insert(value) }
      for ( value <- list ) {
          assert( inserted.contains(value) , "tree does not contain the inserted value! Teszteset: " + list )
        }
      for(i <- 1 to 100 ) {
        val value = Random.nextInt()
        assert( inserted.contains(value) == list.contains(value), "contains error in: " + list + " contains " + value )
      }
    }
  }

 */
}